Summary: The Perl programming language.
Summary(de): Die Perl-Programmiersprache
Name: perl
Version: 5.600
%define fakeversion 5.6.0
Release: 4mdk
Requires: %{name}-base
Provides: perl-5.00503
Copyright: GPL
Group: Development/Perl
#ftp://ftp.linux.activestate.com/pub/staff/gsar/APC/5.6.0/perl-5.6.0.tar.gz
Source0: ftp://ftp.perl.org/pub/perl/CPAN/src/5.0/maint/perl-%{fakeversion}.tar.bz2
Source4: %{name}.menu
Patch0:  perl5.005_02-buildsys.patch.bz2
Patch2: perl5.005_61-nodb.patch.bz2
Patch3: perl5-norootcheck.patch.bz2
Buildroot: /var/tmp/perl-root

%package base
Version: %{version}
Summary: The Perl programming language (base).
Group: Development/Perl

%description
Perl is a high-level programming language with roots in C, sed, awk
and shell scripting.  Perl is good at handling processes and files,
and is especially good at handling text.  Perl's hallmarks are
practicality and efficiency.  While it is used to do a lot of
different things, Perl's most common applications (and what it excels
at) are probably system administration utilities and web programming.
A large proportion of the CGI scripts on the web are written in Perl.
You need the perl package installed on your system so that your
system can handle Perl scripts.

You need perl-base to have a full perl.

%description base
Perl is a high-level programming language with roots in C, sed, awk
and shell scripting.  Perl is good at handling processes and files,
and is especially good at handling text.  Perl's hallmarks are
practicality and efficiency.  While it is used to do a lot of
different things, Perl's most common applications (and what it excels
at) are probably system administration utilities and web programming.
A large proportion of the CGI scripts on the web are written in Perl.
You need the perl package installed on your system so that your
system can handle Perl scripts.

This is the base package.

%description -l de
Perl ist eine High-level-Programmiersprache mit Wurzeln in C, sed, awk und
Shell-Skripts. Perl kann gut Prozesse und Dateien verwalten, und ist
besonders gut zur Bearbeitung von Text. Perl ist praktisch und effizient.
Whrend es fr viele verschiedene Dinge eingesetzt wird, wird es vorwiegend
in der Systemadministration und zur Webprogrammierung eingesetzt.
Ein groer Anteil aller CGI-Scripts ist in Perl geschrieben.
Sie brauchen das Perl-Paket, damit Sie Perl-Skripts ausfhren knnen.

%prep
%setup -q -n perl-%{fakeversion}
%patch0 -p1 -b .buildsys
%patch2 -p1
%patch3 -p1
find . -name \*.orig -exec rm -fv {} \;

%build
# this is gross
cat > config.over <<EOF
installprefix=$RPM_BUILD_ROOT/usr
test -d \$installprefix || mkdir \$installprefix
test -d \$installprefix/bin || mkdir \$installprefix/bin
installarchlib=\`echo \$installarchlib | sed "s!\$prefix!\$installprefix!"\`
installbin=\`echo \$installbin | sed "s!\$prefix!\$installprefix!"\`
installman1dir=\`echo \$installman1dir | sed "s!\$prefix!\$installprefix!"\`
installman3dir=\`echo \$installman3dir | sed "s!\$prefix!\$installprefix!"\`
installprivlib=\`echo \$installprivlib | sed "s!\$prefix!\$installprefix!"\`
installscript=\`echo \$installscript | sed "s!\$prefix!\$installprefix!"\`
installsitelib=\`echo \$installsitelib | sed "s!\$prefix!\$installprefix!"\`
installsitearch=\`echo \$installsitearch | sed "s!\$prefix!\$installprefix!"\`
EOF

sh Configure -des -Dprefix=/usr -Darchname=${RPM_ARCH}-linux -Dd_dosuid \
	-Dd_semctl_semun -Di_db -Di_ndbm -Di_gdbm -Ud_csh \
	-Dman3dir=/usr/lib/perl5/man/man3 -Doptimize="$RPM_OPT_FLAGS"

uname -a | grep -qi SMP && make -j 2 || make

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
make install
install -m 755 utils/pl2pm $RPM_BUILD_ROOT/usr/bin/pl2pm

# Generate *.ph files with a trick. Is this sick or what ?
make all -f - <<EOF
PKGS	= glibc-devel gdbm-devel gpm-devel libgr-devel libjpeg-devel \
	  libpng-devel libtiff-devel ncurses-devel popt \
	  zlib-devel binutils libelf e2fsprogs-devel pam pwdb \
	  rpm-devel
STDH	= \$(filter /usr/include/%%, \$(shell rpm -q --queryformat '[%%{FILENAMES}\n]' \$(PKGS)))
STDH	+=\$(wildcard /usr/include/linux/*.h) \$(wildcard /usr/include/asm/*.h) \$(wildcard /usr/include/scsi/*.h)
GCCDIR	= \$(shell gcc --print-file-name include)
GCCH	= \$(filter \$(GCCDIR)/%%, \$(shell rpm -q --queryformat '[%%{FILENAMES}\n]' gcc))

PERLLIB = \$(RPM_BUILD_ROOT)/usr/lib/perl5/%{fakeversion}
PERL	= PERL5LIB=\$(PERLLIB) \$(RPM_BUILD_ROOT)/usr/bin/perl
PHDIR	= \$(PERLLIB)/\${RPM_ARCH}-linux
H2PH	= \$(PERL) \$(RPM_BUILD_ROOT)/usr/bin/h2ph -d \$(PHDIR)/

all: std-headers gcc-headers

std-headers: \$(STDH)
	cd /usr/include && \$(H2PH) \$(STDH:/usr/include/%%=%%)

gcc-headers: \$(GCCH)
	cd \$(GCCDIR) && \$(H2PH) \$(GCCH:\$(GCCDIR)/%%=%%)
EOF

# From INSTALL:
# Edit $archlib/Config.pm and $archlib/.packlist to change all the
# install* variables back to reflect where everything will
# really be installed.  (That is, change /tmp/perl5 to /opt/perl
# everywhere in those files.)
# Check the scripts in $scriptdir to make sure they have the correct
# #!/wherever/perl line.

# Fix scripts
eval `./perl -I lib -V:installbin`; \
find $installbin -print | \
    while read file ; do
	./perl -i -p -e "s|$RPM_BUILD_ROOT||g" -e ' if $. < 3;' $file
    done

# Fix the rest of the stuff
eval `./perl -I lib -V:installprefix`
find $installprefix/lib/perl5 -name .packlist -o -name perllocal.pod | \
    while read file ; do    
	./perl -i -p -e "s|$RPM_BUILD_ROOT||g;" $file
    done

# Fix Config.pm.
# Must be last since the edits depend on the unmodified Config.pm.
eval `./perl -I lib -V:installarchlib`
./perl -i -p -e "s|$RPM_BUILD_ROOT||g;" $installarchlib/Config.pm

(
    cd $RPM_BUILD_ROOT/usr/bin/
    ln -sf perl5 perl
    ln -s perl%{fakeversion} perl5
)

(
   cd $RPM_BUILD_DIR/perl-%{fakeversion}

   cat > perl-base.list <<EOF
%defattr(-,root,root)
/usr/bin/perl
/usr/bin/perl5
/usr/bin/perl%{fakeversion}
%dir /usr/lib/perl5/
%dir /usr/lib/perl5/%{fakeversion}/
%dir /usr/lib/perl5/%{fakeversion}/File/
/usr/lib/perl5/%{fakeversion}/File/Basename.pm
/usr/lib/perl5/%{fakeversion}/File/Find.pm
/usr/lib/perl5/%{fakeversion}/File/Path.pm
%dir /usr/lib/perl5/%{fakeversion}/Time/
/usr/lib/perl5/%{fakeversion}/Time/Local.pm
%dir /usr/lib/perl5/%{fakeversion}/%{_arch}-linux/
%dir /usr/lib/perl5/%{fakeversion}/%{_arch}-linux/IO/
/usr/lib/perl5/%{fakeversion}/%{_arch}-linux/IO/Handle.pm
/usr/lib/perl5/%{fakeversion}/%{_arch}-linux/IO/Seekable.pm
/usr/lib/perl5/%{fakeversion}/%{_arch}-linux/IO/Select.pm
/usr/lib/perl5/%{fakeversion}/%{_arch}-linux/IO/Socket.pm
%dir /usr/lib/perl5/%{fakeversion}/%{_arch}-linux/auto/
%dir /usr/lib/perl5/%{fakeversion}/%{_arch}-linux/auto/DynaLoader/
/usr/lib/perl5/%{fakeversion}/%{_arch}-linux/auto/DynaLoader/dl_findfile.al
%dir /usr/lib/perl5/%{fakeversion}/%{_arch}-linux/auto/IO/
/usr/lib/perl5/%{fakeversion}/%{_arch}-linux/auto/IO/IO.bs
/usr/lib/perl5/%{fakeversion}/%{_arch}-linux/auto/IO/IO.so
%dir /usr/lib/perl5/%{fakeversion}/%{_arch}-linux/auto/POSIX/
/usr/lib/perl5/%{fakeversion}/%{_arch}-linux/auto/POSIX/POSIX.bs
/usr/lib/perl5/%{fakeversion}/%{_arch}-linux/auto/POSIX/POSIX.so
/usr/lib/perl5/%{fakeversion}/%{_arch}-linux/auto/POSIX/tmpfile.al
%dir /usr/lib/perl5/%{fakeversion}/%{_arch}-linux/auto/Socket/
/usr/lib/perl5/%{fakeversion}/%{_arch}-linux/auto/Socket/Socket.bs
/usr/lib/perl5/%{fakeversion}/%{_arch}-linux/auto/Socket/Socket.so
%dir /usr/lib/perl5/%{fakeversion}/%{_arch}-linux/auto/re/
/usr/lib/perl5/%{fakeversion}/%{_arch}-linux/auto/re/re.so
/usr/lib/perl5/%{fakeversion}/%{_arch}-linux/auto/re/re.bs
/usr/lib/perl5/%{fakeversion}/%{_arch}-linux/Config.pm
/usr/lib/perl5/%{fakeversion}/%{_arch}-linux/DynaLoader.pm
/usr/lib/perl5/%{fakeversion}/%{_arch}-linux/POSIX.pm
/usr/lib/perl5/%{fakeversion}/%{_arch}-linux/Socket.pm
/usr/lib/perl5/%{fakeversion}/%{_arch}-linux/re.pm
/usr/lib/perl5/%{fakeversion}/AutoLoader.pm
/usr/lib/perl5/%{fakeversion}/Carp.pm
/usr/lib/perl5/%{fakeversion}/Cwd.pm
/usr/lib/perl5/%{fakeversion}/DirHandle.pm
/usr/lib/perl5/%{fakeversion}/Exporter.pm
/usr/lib/perl5/%{fakeversion}/FileHandle.pm
/usr/lib/perl5/%{fakeversion}/SelectSaver.pm
/usr/lib/perl5/%{fakeversion}/Symbol.pm
/usr/lib/perl5/%{fakeversion}/integer.pm
/usr/lib/perl5/%{fakeversion}/strict.pm
/usr/lib/perl5/%{fakeversion}/vars.pm
EOF

   cat > perl.list <<EOF
%defattr(-,root,root)
%attr(4711,root,root) /usr/bin/sperl%{fakeversion}
%attr(4711,root,root) /usr/bin/suidperl
%doc Artistic README README.Y2K 
/usr/bin/a2p
/usr/bin/c2ph
/usr/bin/h2ph
/usr/bin/h2xs
/usr/bin/perlbug
/usr/bin/perldoc
/usr/bin/pl2pm
/usr/bin/splain
/usr/bin/perlcc
/usr/bin/s2p
/usr/bin/find2perl
/usr/bin/pod2man
/usr/bin/pod2html
/usr/bin/pod2latex
/usr/bin/pod2text
/usr/bin/pstruct
/usr/man/man*/*
/usr/lib/perl5/man
/usr/lib/menu/*
EOF

   (cd $RPM_BUILD_ROOT ; find usr/lib/perl5/%{fakeversion} ! -type d -printf "/%%p\n") >> perl.list
   (cd $RPM_BUILD_ROOT ; find usr/lib/perl5/%{fakeversion}   -type d -printf "%%%%dir /%%p\n") >> perl.list
   perl -ni -e 'BEGIN { open F, "perl-base.list"; /^%/ or $s{$_} = 1 foreach <F>; } print unless $s{$_}' perl.list
)

install -d $RPM_BUILD_ROOT/usr/lib/menu
install -m 644 %{SOURCE4} $RPM_BUILD_ROOT/usr/lib/menu/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post 
if [ -x /usr/bin/update-menus ]; then
  /usr/bin/update-menus
fi

%postun
if [ "$1" = 0 ]; then
  if [ -x /usr/bin/update-menus ]; then
      /usr/bin/update-menus
  fi
fi  

%files -f perl.list

%files base -f perl-base.list

%changelog
* Fri Mar 31 2000 Pixel <pixel@mandrakesoft.com> 5.600-4mdk
- fix a bug causing missing .ph's

* Tue Mar 28 2000 Pixel <pixel@mandrakesoft.com> 5.600-3mdk
- really add menu

* Mon Mar 27 2000 Pixel <pixel@mandrakesoft.com> 5.600-2mdk
- add menu

* Thu Mar 23 2000 Pixel <pixel@mandrakesoft.com> 5.600-1mdk
- change version number for backward compatibility :(
(serial is not enough, cuz there are some requires >= 5.00503)

* Thu Mar 23 2000 Pixel <pixel@mandrakesoft.com> 5.6.0-1mdk
- new version

* Tue Mar 21 2000 Pixel <pixel@mandrakesoft.com> 5.6-0.3mdk
- RC3

* Thu Mar 16 2000 Pixel <pixel@mandrakesoft.com> 5.6-0.2mdk
- RC2

* Thu Mar  9 2000 Pixel <pixel@mandrakesoft.com> 5.6-0.1mdk
- new version

* Wed Mar  1 2000 Pixel <pixel@mandrakesoft.com> 5.5.670-1mdk
- new version

* Thu Feb 24 2000 Pixel <pixel@mandrakesoft.com> 5.5.660-1mdk
- remove the strip'ing and man page bzip'ing
- new version

* Wed Feb  9 2000 Pixel <pixel@mandrakesoft.com> 5.5.650-1mdk
- new version

* Thu Feb  3 2000 Pixel <pixel@mandrakesoft.com> 5.5.640-6mdk
- new version (and new version numbering)

* Mon Jan 17 2000 Franois Pons <fpons@mandrakesoft.com>
- changed asm/*.h to asm*/*.h during .ph generation for sparc.

* Fri Dec 17 1999 Pixel <pixel@mandrakesoft.com>
- clean up
- fixed the reference to the egcs package

* Mon Nov 29 1999 Pixel <pixel@linux-mandrake.com>
- removed the `Provides: perl' in perl-base

* Mon Nov 22 1999 Stefan van der Eijk <s.vandereijk@chello.nl>
- changed i386 into ${RPM_ARCH}

* Mon Oct 25 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Fix forget manpages from %files.

* Thu Oct 14 1999 Pixel <pixel@linux-mandrake.com>

- create hackperl based on perl's spec
- split in two packages
- removed csh dependencie
- merged redhat's spec (not everything)

* Mon Jul 12 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>

- ln /usr/lib/perl5 to /usr/lib/perl5%{current_version}
- bzip2 manpages.

* Tue Apr 13 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>

- Add patch from RedHat6.0.
- Update to 5.005_03

* Sat Apr 10 1999 Bernhard Rosenkraenzer <bero@linux-mandrake.com>
- Mandrake adaptions
- bzip2 man/info pages
- handle RPM_OPT_FLAGS
- add de locale

* Thu Jan 07 1999 Cristian Gafton <gafton@redhat.com>
- guilty of the inlined Makefile in the spec file
- adapted for the arm build

* Wed Sep 09 1998 Preston Brown <pbrown@redhat.com>
- added newer CGI.pm to the build
- changed the version naming scheme around to work with RPM

* Sun Jul 19 1998 Jeff Johnson <jbj@redhat.com>
- attempt to generate *.ph files reproducibly

* Mon Jun 15 1998 Jeff Johnson <jbj@redhat.com>
- update to 5.004_04-m4 (pre-5.005 maintenance release)

* Tue Jun 12 1998 Christopher McCrory <chrismcc@netus.com
- need stdarg.h from gcc shadow to fix "use Sys::Syslog" (problem #635)

* Fri May 08 1998 Cristian Gafton <gafton@redhat.com>
- added a patch to correct the .ph constructs unless defined (foo) to read
  unless(defined(foo))

* Thu May 07 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Tue Mar 10 1998 Cristian Gafton <gafton@redhat.com>
- fixed strftime problem

* Sun Mar 08 1998 Cristian Gafton <gafton@redhat.com>
- added a patch to fix a security race
- do not use setres[ug]id - those are not implemented on 2.0.3x kernels

* Mon Mar 02 1998 Cristian Gafton <gafton@redhat.com>
- upgraded to 5.004_04 - 5.004_01 had some nasty memory leaks.
- fixed the spec file to be version-independent

* Fri Dec 05 1997 Erik Troan <ewt@redhat.com>
- Config.pm wasn't right do to the builtrooting

* Mon Oct 20 1997 Erik Troan <ewt@redhat.com>
- fixed arch-specfic part of spec file

* Sun Oct 19 1997 Erik Troan <ewt@redhat.com>
- updated to perl 5.004_01
- users a build root

* Thu Jun 12 1997 Erik Troan <ewt@redhat.com>
- built against glibc

* Tue Apr 22 1997 Erik Troan <ewt@redhat.com>
- Incorporated security patch from Chip Salzenberg <salzench@nielsenmedia.com>

* Fri Feb 07 1997 Erik Troan <ewt@redhat.com>
- Use -Darchname=i386-linux 
- Require csh (for glob)
- Use RPM_ARCH during configuration and installation for arch independence
